/***************************************************************************
                          globject.h  -  description
                             -------------------
    begin                : Fre Feb 7 2003
    copyright            : (C) 2003 by Roman Roelofsen
    email                : r.roelofsen@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLOBJECT_H
#define GLOBJECT_H

#include <qwidget.h>
#include <qgl.h>

/**
  *@author Roman Roelofsen
  */

class GLObject : public QGLWidget  {
   Q_OBJECT
public: 
	GLObject(QWidget *parent=0, const char *name=0);
	~GLObject();
  	void 	setColors(QColor new_fg_color, QColor new_bg_color);
   	void 	setObject(QString new_o_name);

public slots:
    	void	setRotation(int x, int y, int z);

protected:
    	void	initializeGL();
    	void	paintGL();
    	void	resizeGL( int w, int h );

private:
	GLuint 	object;
	GLfloat xRot, yRot, zRot;
	GLfloat scale;
	QColor 	fg_color;
	QColor 	bg_color;
	QString o_name;
};

#endif
