/***********************************************************************************
		        	kcube.h
                             -------------------
    begin                : Mon Jan 27 19:29:59 CET 2003
    copyright           : (C) 2003 by Roman Roelofsen
    email                 : r.roelofsen@web.de
 ***********************************************************************************

 ***********************************************************************************
 *										
 *   This program is free software; you can redistribute it and/or modify  	
 *   it under the terms of the GNU General Public License as published by  	
 *   the Free Software Foundation; either version 2 of the License, or     	
 *   (at your option) any later version.                                   		
 *                                                                         		
 ***********************************************************************************
 */
 
#ifndef KCUBE_H
#define KCUBE_H

#ifdef HAVE_CONFIG_H
        #include <config.h>
#endif

#include <kpanelapplet.h>
#include <qstring.h>
#include <ksimpleconfig.h>

#include <qpainter.h>
#include <qtimer.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qgl.h>

#include "globject.h"

#include "PrefForm.h"

class Kcube : public KPanelApplet
{
Q_OBJECT

public:
	Kcube(const QString& configFile, Type t = Normal, int actions = 0, QWidget *parent = 0, const char *name = 0);
	~Kcube();
	int 	widthForHeight( int height ) const;
	int 	heightForWidth( int width) const;

protected:
	void 	mousePressEvent(QMouseEvent *me);
	
private:
	void 	loadConfig();
	void 	saveConfig();
	void 	setColors(QString load);
	void 	about();
	void 	preferences();	
	int	previous_total, previous_used;
	int	calc_cpu_total();
	int	rot_x, rot_y, rot_z;
	int	load;
		
	KSimpleConfig	*config;
	PrefForm	*prefform;
	QVBoxLayout	*vlayout;
	QLabel		*label_load;
	GLObject	*globject;
	QTimer		*cpu_timer, *draw_timer;

private slots:
	void 	cpu_timer_event();
	void 	draw_timer_event();
};

#endif
